/* eslint-disable prefer-const */
const Command = require('../../Structures/Command');
const errors = require('../../utils/errors.js');
const { channelID, adminRoles } = require('../../../config.json');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			aliases: ['speak'],
			description: 'Mute everyone in the channel.',
			category: 'Utility'
		});
	}

	// eslint-disable-next-line consistent-return
	async run(message) {
		if (!message.member.hasPermission('CONNECT')) return errors.noBotPerms(message, 'CONNECT');
		let hasNedeedRole = ['false'];
		let neededRole = [];
		adminRoles.forEach(element => {
			const foundRole = message.guild.roles.cache.find(rl => rl.id === element);
			const roleneeded = message.member.roles.cache.has(foundRole.id);
			if (roleneeded === true || message.member.hasPermission('ADMINISTRATOR')) {
				const pos = hasNedeedRole.indexOf('false');
				hasNedeedRole.splice(pos, 1);
				hasNedeedRole.push('true');
			}
			if (roleneeded === false) {
				neededRole.push(foundRole.name);
			}
		});
		if (hasNedeedRole === 'true' || message.member.hasPermission('ADMINISTRATOR')) {
			message.delete();
			const channel = this.client.channels.cache.get(channelID);
			if (!channel) return message.reply('The channel does not exist!');
			for (let member of channel.members) {
				member[1].voice.setMute(false);
			}
		} else {
			return errors.noPerms(message, neededRole);
		}
	}

};
